/* Combining Levinsohn-Petrin 2-step estimation procedure and comparable OP and EOP */

capture program drop blevpet
program define blevpet
    version 7
    if "`1'" == "?" {
        global S_1 "olslbl olslwh olsm olsk lplbl lplwh lpm lpk oplbl oplwh opm opinv opk eoplbl eoplwh eopm eopmpen eopk"
        exit
    }

    capture noi reg lnoutput lnlabfbl lnlabfwh lnintmed lnapktot, nocons
    if _rc== 0 {
        local olslbl  = _b[lnlabfbl]
        local olslwh  = _b[lnlabfwh]
        local olsm = _b[lnintmed]
        local olsk = _b[lnapktot]
        }
    else {
        local olslbl  = .
        local olslwh  = .
        local olsm = .
        local olsk = .
        }
   capture noi levpetmam lnoutput, free(lnlabfbl lnlabfwh) proxy(lnintmed) capital(lnapktot) revenue justid reps(0) i(_firm) t(year)
   if _rc== 0 {
       local lplbl  = _b[lnlabfbl]
       local lplwh  = _b[lnlabfwh]
       if $converrs~=1 { local lpm = _b[lnintmed] 
                         local lpk = _b[lnapktot] }
       else { local lpm = . 
              local lpk = . } 
       }
   else {
       local lplbl  = .
       local lplwh  = .
       local lpm = .
       local lpk = .
       }
   capture noi levpetmam lnoutput, free(lnlabfbl lnlabfwh lnintmed) proxy(nttotinv) capital(lnapktot) revenue justid reps(0) i(_firm) t(year)
   if _rc== 0 {
       local oplbl  = _b[lnlabfbl]
       local oplwh  = _b[lnlabfwh]
       local opm = _b[lnintmed]
       if $converrs~=1 { local opinv = _b[nttotinv] 
                         local opk = _b[lnapktot] }
       else { local opinv = . 
              local opk = . } 
       }
   else {
       local oplbl  = .
       local oplwh  = .
       local opm = .
       local opinv = .
       local opk = .
       }
   capture noi levpetmam lnoutput, free(lnlabfbl lnlabfwh lnintmed) proxy(ntinv_mpen) capital(lnapktot) revenue justid reps(0) i(_firm) t(year)
   if _rc== 0 {
       local eoplbl  = _b[lnlabfbl]
       local eoplwh  = _b[lnlabfwh]
       local eopm = _b[lnintmed]
       if $converrs~=1 { local eopmpen = _b[ntinv_mpen] 
                         local eopk = _b[lnapktot] }
       else { local eopmpen = . 
              local eopk = . } 
       }
   else {
       local eoplbl  = .
       local eoplwh  = .
       local eopm = .
       local eopmpen = .
       local eopk = .
       }

    post `1' (`olslbl') (`olslwh') (`olsm') (`olsk') (`lplbl') (`lplwh') (`lpm') (`lpk') (`oplbl') (`oplwh') (`opm') (`opinv') (`opk') (`eoplbl') (`eoplwh') (`eopm') (`eopmpen') (`eopk')
end
